#include <stdio.h>
#include <stdlib.h>
#include "midas.h"

void process_event(HNDLE hBuf, HNDLE request_id, EVENT_HEADER *pheader, void *pevent)
{
static INT bytes_received, start=0, stop;

  /* accumulate received event size */
  bytes_received += pheader->data_size;

  /* calculate rates each second */
  if (ss_millitime() - start > 1000)
    {
    stop = ss_millitime();
    if (stop != start)
      printf("Rate: %1.2lf MB/sec\n",
        bytes_received/1024.0/1024.0 /(stop/1000.0 - start/1000.0));

    start = stop;
    bytes_received = 0;
    }
}

main()
{
INT hBuf, status, request_id;

  /* connect to experiment */
  cm_connect_experiment("", "", "Consumer", NULL);

  /* open the event buffer */
  bm_open_buffer("SYSTEM", 0x100000, &hBuf);

  /* set the buffer cache size */
  bm_set_cache_size(hBuf, 50000, 0);

  /* place a request for a specific event id "1" */
  bm_request_event(hBuf, 1, TRIGGER_ALL, GET_ALL, &request_id, 
                   process_event);
  
  do
    {
    status = cm_yield(1000);
    } while (status != RPC_SHUTDOWN && status != SS_ABORT);

  cm_disconnect_experiment();
  return 1;
}
