#include <stdio.h>
#include "midas.h"
#include "msystem.h"

INT running;     /* stopped:0, started:1 */
INT serial = 0;   /* event serial number */
INT run_number = 0;        /* run number */

HNDLE hBuf;  /* buffer handle for events */

INT tr_start(INT rn, char *error)
{
  printf("Start run %d\n", rn);

  serial = 0;
  run_number = rn;
  running = TRUE;

  return CM_SUCCESS;
}

INT tr_stop(INT rn, char *error)
{
  running = FALSE;
  rpc_flush_event();
  bm_flush_cache(hBuf, SYNC);

  printf("Stop run %d\n", rn);

  return CM_SUCCESS;
}

main()
{
INT           status, size=1000, id=0;
DWORD         last_time=0;
char          event[2000];
char          host_name[256];
char          dash[] = "-\\|/";

  printf("Host to connect: ");
  ss_gets(host_name, 256);

  /* now connect to server */
  status = cm_connect_experiment(host_name, "", "MiniFE", NULL);
  if (status != CM_SUCCESS)
    return 1;
                         
  printf("Frontend connected to %s\n", host_name[0] ? host_name : "localhost");

  cm_register_transition(TR_START, tr_start);
  cm_register_transition(TR_STOP, tr_stop);

  /* open event bufer and set cache size */
  bm_open_buffer(EVENT_BUFFER_NAME, EVENT_BUFFER_SIZE, &hBuf);
  bm_set_cache_size(hBuf, 0, 100000);

  do
    {
    if (!running)
      {
      /* if run is not started, call yield with a timeout of 1s */
      status = cm_yield(1000);
      if (status == RPC_SHUTDOWN) 
        break;                                
      }
    else
      {
      /* if run is started, call yield with a timeout of 0 once each 300 ms */
      if (ss_millitime() - last_time > 300)
        {
        printf("%c\r", dash[id++ % 4]);
        fflush(stdout);

        status = cm_yield(0);
        if (status == RPC_SHUTDOWN) 
          break;
        last_time = ss_millitime();
        }
      }

    /* if run is started, send event */
    if (running)
      {
      /* compose event header, empty event */
      bm_compose_event((EVENT_HEADER *) event, 1, 1, size, serial++);

      /* send event */
      rpc_send_event(hBuf, event, size+sizeof(EVENT_HEADER), SYNC);
      }

    } while (TRUE);

  cm_disconnect_experiment();

  return 1;
}
