package ca.triumf.midas;

/**
 * The MessageListener interface is used to define a callback to be called by 
  the message listening mechanism in the Experiment class. A task can be spawned to
  display incoming messages intended for this client, or an action can be taken whenever
  a message is sent.
  
 */
 
public interface MessageListener { 
	
	/**
	 * A method that is called whenever an meesage for the client is received.
	 
	 @param message the message from the Midas server
	 */
  public void receiveMessage(String message); 
}