package ca.triumf.midas;

import java.io.*;

/**
 * A subclass of Exception to identify an Unknown Experiment Exception. This 
  will be thrown if an attempt to connect to the Midas server has
  failed due to an unrecognized experiment name.
  <P>
  See the exptab file and the MIDAS_DIR and MIDAS_EXPTAB environment variables on the 
  server machine for valid experiment names.
 */
public class UnknownExpException extends java.io.IOException {
	
	/**
	 * Creates a new object of type UnknownExpException with the passed String.
	  
	  @param exp a String describing the exception
	 */
  public UnknownExpException(String exp) {
	  super(exp);
	}
}